//The type of map (svg or png).
var type;
//The reference node for the map in the "index.svg".
var svgMap;
//The reference node for the map in the "plotX.svg".
var nodeMap;
//The id number of the current plot
var plotNumber;
//The current node for index plot.
var nodePlot;
//The id number of the current page.
var pageNumber;
//The current node for index page.
var nodePage = null;
//The current remark selected
var nodeSelect;


//The main function called when "index.svg" document is loaded.
function init(evt,typeArg) {

	svgMap = document.getElementById("svgMap");
        nodeRemarkToDisplay = document.getElementById("textRemark");
	positionMapX = document.getElementById("positionMapX");
	positionMapY = document.getElementById("positionMapY");
	
	type=typeArg;

	setNewPlot(1);

	initTogglesPlots();
}

/*Init the toggles on the top of plot number to prevent*/
/*operator on the presence of errors or informations.  */
function initTogglesPlots()
{
  for(var i =1;i<6;i++)
	{
	  var plot = "plot" + i;
	  var nodePlot = document.getElementById(plot);
	  var nodeToggleInfo = getChildById(nodePlot,"toggleInfo");
	  nodeToggleInfo.setAttribute("display","none");
          var nodeToggleError = getChildById(nodePlot,"toggleError");
          nodeToggleError.setAttribute("display","none");

	   plotInfoNbr=0;
	   plotErrorNbr=0;

	  getURL(type +"/" + plot + "/Remarks.xml", informPlotsAboutRemarks);

	  
	  if (plotInfoNbr > 0)
	   nodeToggleInfo.setAttribute("display","inline");
          if (plotErrorNbr > 0)
	   nodeToggleError.setAttribute("display","inline");
	}

}
function setNewPlot(num)
{
  

  if (nodePlot != null)
    nodePlot.removeAttribute("class");

  plotNumber = num;
  setNewPage(1);

  var plot = "plot" + plotNumber;
  nodePlot = document.getElementById(plot);
  nodePlot.setAttribute("class","selectedPlot");

  getURL("Infos.xml", displayGeneralInformation);
  
}

/*Sets a new page.*/
function setNewPage(num)
{

  var nodeMessageInit = document.getElementById("message");
  nodeMessageInit.setAttribute("display","true");

  var plot = "plot" + plotNumber;

  var page = "page" + num;
  pageNumber = num;

  var map = getChildById(svgMap,"map");
  
  if (type == "svg")
  {
    getMapForSvg(type + "/" + plot + "/" + page + "." + type,map);
  }
  else
    getMapForPng(type + "/" + plot + "/" + page + "." + type,map);

   var vbox = svgMap.getAttribute("viewBox");
   var params  = vbox.split(/\s+/);

   /*250 car (1100 - 600) / 2 => voir le translate dans le index.svg*/
   halfWidth = (params[2] / 2.0); //- 250 ;
   halfHeight = params[3] / 2.0;  //- 250;
   x0=0;
   y0=0;
   xT=0;
   yT=0;
   scale=1;
   
   
   
   var plot = "plot" + plotNumber;
   
   getURL(type +"/" + plot + "/Remarks.xml", drawCircleRemarks);
  
   

  if (nodePage != null)
    nodePage.removeAttribute("class");

  nodePage = document.getElementById(page);
  nodePage.setAttribute("class","selectedPage");

  getURL(type +"/" + plot + "/Remarks.xml", informPagesAboutRemarks);

}


/*Sets the next plot*/
function nextPlot()
{

  if (plotNumber < 6)
  {
    plotNumber = plotNumber + 1;
    setNewPlot(plotNumber);
  }

}

/*Sets the previos plot*/
function previousPlot()
{

  if (plotNumber > 1)
  {
    plotNumber = plotNumber - 1;
    setNewPlot(plotNumber);
  }

}

/*Sets the next page*/
function nextPage()
{

  if (pageNumber < 12)
  {
    pageNumber = pageNumber + 1;
    setNewPage(pageNumber);
  }

}

/*Sets the previous page*/
function previousPage()
{

  if (pageNumber > 1)
  {
    pageNumber = pageNumber - 1;
    setNewPage(pageNumber);
  }

}




/*Function to load a svg map*/
function getMapForSvg(file,where) {
  
  //Check that the image element for PNG is not 
  //present in the index file.
  var nodeImage = document.getElementById("imageMap");
  if (nodeImage!=null) 
  {
    where.removeChild(nodeImage);
  }

  var nodeFils = where.getFirstChild();
  if (nodeFils!=null) 
  {
    where.removeChild(nodeFils);
  }

  getURL(file, mapLoaded);
  url=file;
 
}

/*extract the frament from the svg map*/
function mapLoaded(data) {
  var nodeMessageInit = document.getElementById("message");
  var string = '';
  if(data.success) {
			string = data.content;
			nodeMessageInit.setAttribute("display","none");
		} else {
		        nodeMessageInit.setAttribute("display","true");
			return;
		}
   var fragment = parseXML(string, document);

   
   var map = svgMap.getElementById("map");
   map.appendChild(fragment);

   //The current node for the map is the svg node from "plotX.svg"
   nodeMap = getChildByTagName(map,"svg");
   
}


/*Function to load a svg map*/
function getMapForPng(file,where) {
  
  var nodeImage = document.getElementById("imageMap");
  nodeImage.setAttribute("xlink:href",file);

  //The current node for the map is the node from "index.svg"
  nodeMap = svgMap;
}





