//Sub routines called from loadMap.js to handler navigation elements.

//The place where to display the X coordinate.
var positionMapX;
//The place where to display the Y coordinate.
var positionMapY;
//The current x0 fixed by pan tools. 
var x0;
//The current y0 fixed by pan tools. 
var y0;
//The half of the width announced by the view box.
var halfWidth;
//The half of the height announced by the view box.
var halfHeight;
//the current scale.
var scale;
//the x current translation (center of the panel).
var xT;
//the y current translation (center of the panel).
var yT;



/*Main function called from zoom tools*/
function zoomIt(type)
{

  var map = nodeMap.getElementById("map");

  var transform = map.getAttribute('transform');
  scale = extractScale(transform);
  xT = extractXTranslate(transform);
  yT = extractYTranslate(transform);


  if (type=='in') scale = scale*1.1;
  else if (type=='out') scale = scale*0.9;
  else if (type=='def') 
  {
      scale = 1.85;  // 1100 / 600
      x0=0;
      y0=0;
  }
  else if (type=='full') 
  {
      scale = 1;  
      x0=0;
      y0=0;
  }
  
  
  //First translate the middle of the current window
  //to the high left point.
  var centerX = halfWidth;
  var centerY = halfHeight;
  
  xT = x0 - ((centerX) * (scale-1));
  yT = y0 - ((centerY) * (scale-1));

  //Second scale on this point.
  map.setAttribute('transform','translate(' + xT + ',' + yT + ')' + 'scale(' + scale + ')'   );

  transform = map.getAttribute('transform');
  scale = extractScale(transform);
  xT = extractXTranslate(transform);
  yT = extractYTranslate(transform);
}
/*Main function called from zoom tools*/

//Extract the scale from the current svg "transformation" string .
function extractScale(transform)
{
  var p1 = transform.indexOf( "scale", 0);
  var scale = 1
  if (p1 != -1)
    {
      p1 = transform.indexOf( "(", p1);
      var p2 = transform.indexOf( ")", p1+1);
      scale = transform.substr(p1+1,p2-p1-1);
    }

  return(new Number(scale));
 
}

//Extract the XT from the current svg "transformation" string .
function extractXTranslate(transform)
{
  var p1 = transform.indexOf( "translate", 0);
  var x = 0
  if (p1 != -1)
    {
      p1 = transform.indexOf( "(", p1);
      var p2 = transform.indexOf( ",", p1+1);
      x = transform.substr(p1+1,p2-p1-1);
    }

  return(new Number(x));
 
}

//Extract the YT from the current svg "transformation" string .
function extractYTranslate(transform)
{
  var p1 = transform.indexOf( "translate", 0);
  var y = 0
  if (p1 != -1)
    {
      p1 = transform.indexOf( ",", p1);
      var p2 = transform.indexOf( ")", p1+1);
      y = transform.substr(p1+1,p2-p1-1);
    }
  
  return(new Number(y));
 
}

/*Main function called from pan tools*/
function pan(sensX,sensY,coef)
{
  var map = nodeMap.getElementById("map");
  var transform = map.getAttribute('transform');
  var x = extractXTranslate(transform);
  var y = extractYTranslate(transform);
  var scale = extractScale(transform);
  if (sensX != 0)
  {
    x = x + (sensX*halfWidth*coef);
    x0 = x;
  }
  if (sensY != 0)
  {
    y = (y + (sensY*halfHeight*coef));
    y0 = y;
  }
  
  
  map.setAttribute('transform','translate(' + x + ',' + y + ') scale(' + scale + ')' );

  transform = map.getAttribute('transform');
  scale = extractScale(transform);
  xT = extractXTranslate(transform);
  yT = extractYTranslate(transform);

  
}

//Function allows to update cursor x y.
function updateCursor(e) {

            // Get the mouse x and y coordinates
            var x = e.clientX;
            var y = e.clientY;

	    
	    x = Math.round((x - xT) / scale);
	    y = Math.round((y - yT) / scale);

	    //Comment prendre la partie entire.
	    
	    positionMapX.firstChild.setNodeValue("X : " + x);
	    positionMapY.firstChild.setNodeValue("Y : " + y);
            
}


//////////////////////////////////////////Xml tools//////////////////////////
function getChildById(node,id)
{
  var nodesListe = node.getChildNodes();
  for (var i = 0; i<nodesListe.length; i++) 
   {
     var child  = nodesListe.item(i);
     if (child.nodeType != 1) continue;
     if (child.id == id) return(child);
     child = getChildById(child,id);
     if (child != null) return(child);
   }
  return(null);
}

function getChildByTagName(node,name)
{
  var nodesListe = node.getChildNodes();
  for (var i = 0; i<nodesListe.length; i++) 
   {
     
     var child  = nodesListe.item(i);
     
     if (child.nodeType != 1) continue;
     
     if (child.nodeName == name) return(child);

    
   }
  return(null);
}

function removeChilds(node)
{
  if (node != null)
    {
  var nodesListe = node.getChildNodes();
  for (var i = nodesListe.length-1; i>-1; i--) 
   {
     var child  = nodesListe.item(i);
     node.removeChild(child);
   }
    }
}



